Add proxied attribute to diameter::comm::Message in order to automate end-to-end...
[anna.git] / example / diameter / launcher / DEPLOY.sh
index d574860..ceb04b1 100755 (executable)
-#!/bin/ksh
+#!/bin/bash
 
-# Functions & variables
+#############
+# VARIABLES #
+#############
 SETUPS_DIR=../../../source/diameter/stack/setups
-MSGDTD_DIR=../../../source/diameter/codec/message.dtd
+MSGDTD=../../../include/anna/diameter/codec/message.dtd
+DCTDTD=../../../include/anna/diameter/stack/dictionary.dtd
 BASE_PROT=commands_baseProtocol.xml
-EXEC=/opt/bin/anna/example_diameter_launcher
-DPATH_dflt=$HOME/ADL
 
+# Executables in priority order:
+EXEC_installed=/opt/bin/anna/example_diameter_launcher
+EXECS=( $EXEC_installed ./release/example_diameter_launcher ./debug/example_diameter_launcher )
+
+#############
+# FUNCTIONS #
+#############
 _exit () {
    echo
    echo $1
    echo
-   exit
+   exit 1
 }
 
+usage () {
+  echo "Usage: $0 [deployment_type: a|b|f] [deployment_path]"
+  echo
+  echo "       deployment_type:"
+  echo "          a=advanced"
+  echo "          b=basic"
+  echo "          f=function test client"
+  echo "       deployment_path:"
+  echo "          non-existent path directory."
+  echo
+  echo "       For example:"
+  echo "          $0 b $HOME/ADL/basicServer"
+  echo "          $0 b $HOME/ADL/MMSbalancer"
+  echo "          $0 f $HOME/ADL/tester"
+  echo
+  exit 0
+}
+# $1: deployment type
 createRunScript () {
 
-echo "#!/bin/ksh" > run.sh
-echo "EXE=\`cat .exe 2>/dev/null\`" >> run.sh
-echo "STARTED=\`ps -fea | grep \"\$EXE\" | grep -v grep\`" >> run.sh
-echo "[ \"\$EXE\" != \"\" -a \"\$STARTED\" != \"\" ] && { echo \"Already started!\"; echo \"\$STARTED\" ; exit ; }" >> run.sh
-echo "pre-start.sh" >> run.sh
-echo "> launcher.traces" >> run.sh
-echo "EXE=\"ndl_\`date '+%Y%m%d%H%M%S'\`\"" >> run.sh
-echo "echo \$EXE > .exe"  >> run.sh
-#echo "rm \$EXE 2>/dev/null" >> run.sh
-echo "echo ; echo \"Executable paths:\" ; echo" >> run.sh
-echo "for i in \`ls execs/.*/*\` ; do echo \$i ; done" >> run.sh
-echo "echo ; echo \"Input the executable path:\" ; read path ; while test \"\$path\" = \"\" ; do read path ; done" >> run.sh
-echo "ln -s \$path \$EXE" >> run.sh
-echo >> run.sh
-echo -n "\$EXE " >> run.sh
-for i in `cat args.txt | grep -v "^#"`
-do
-   echo -n "$i " >> run.sh
-done
-echo "&" >> run.sh
-chmod a+x run.sh
-rm args.txt
+  # Basic launcher 'run.sh' will be created at deployment configuration: 
+  [ "$1" = "b" ] && return
+  [ "$1" = "a" ] && exe=ADL-launcher
+  [ "$1" = "f" ] && { exe=ADL-ftclient ; ln -s ADL-launcher $exe ; }
+
+  cat << EOF > run.sh
+#!/bin/bash
+cd \`dirname \$0\`
+EXE=$exe
+STARTED=\`pgrep \$EXE 2>/dev/null\`
+[ \$? -eq 0 ] && { echo "Already started!"; echo "\$STARTED" ; exit 1 ; }
+./pre-start.sh
+0> launcher.trace
+rm -f counters/*
+# Execution line:
+./\$EXE --cntDir counters $(for i in `cat args.txt | grep -v "^#"`; do echo -n "$i "; done)&
+echo \$! > .pid
+EOF
+
+  chmod a+x run.sh
+  rm args.txt
 }
 
 createDictionaryPaths () {
-
-
-for i in stacks/*commands*xml
-do
-   stacks/dependence.sh $i >/dev/null
-   stack=`basename $i`
-   if test "$stack" != "$BASE_PROT"
-   then
+  for i in stacks/*commands*xml
+  do
+    stacks/dependence.sh $i >/dev/null
+    stack=`basename $i`
+    if test "$stack" != "$BASE_PROT"
+    then
       > .dictionary__${stack}
       for j in `cat ${i}.dep`
       do
-         echo "${j},\c" >> .dictionary__${stack}
+        echo -n "${j}," >> .dictionary__${stack}
       done
       echo "stacks/$BASE_PROT,stacks/${stack}" >> .dictionary__${stack}
-   fi
-done
+    fi
+  done
+
+  # Default:
+  ln -s .dictionary__commands_qosControl.xml .dictionary
 
-# Default:
-ln -s .dictionary__commands_qosControl.xml .dictionary
+  # Remove deps:
+  rm -f stacks/*.dep
 }
 
 #############
 # EXECUTION #
 #############
+cd `dirname $0`
 echo
 echo "---------------------------------------"
 echo "Anna Diameter Launcher (ADL) deployment"
 echo "---------------------------------------"
+[ "$1" = "--help" -o "$1" = "-h" ] && usage
+echo " (--help or -h for more info)"
 echo
-echo "Input deployment path [$DPATH_dftl]:"
-read DPATH
-[[ "$DPATH" = "" ]] && DPATH=$DPATH_dflt
-mkdir -p $DPATH
-mkdir $DPATH/stacks
-
 echo "Basic checkings ..."
-[[ ! -f $EXEC ]] && salir "Anna Diameter Launcher (ADL) is not installed in the system. Execute 'sudo scons install' for 'anna' suite."
-[[ ! -d $SETUPS_DIR ]] && salir "Diameter stacks not found ($SETUPS_DIR). Perhaps you executed '$0' out of its parent path."
+available=
+for EXEC in ${EXECS[@]}; do
+  echo -n "Looking executable at '$EXEC' ... "
+  [ -x $EXEC ] && { available=yes ; echo "available !" ; break ; }
+  echo "not found"
+done
+[ -z "$available" ] && _exit "Anna Diameter Launcher (ADL) is not installed neither linked. See README.md (Install section)."
+[ ! -d $SETUPS_DIR ] && _exit "Diameter stacks not found ($SETUPS_DIR)."
 
-echo "Copying ..."
-cp $EXEC $DPATH/launcher
-cp resources/* $DPATH
+echo
+if [ "$1" = "" ]
+then
+  echo
+  echo "Deploy one of these versions:"
+  echo
+  echo " (a)dvanced version:     includes burst management script and templates for different scenarios. Automatic configuration during start."
+  echo " (b)asic version:        4 types of launcher (client, server, balancer, dummy), lightly configured and managed through SIGURS2 method."
+  echo " (f)unction test client: special client with regexp scheduler script based on splitted traffic logs. Requires a server to perform the tests."
+  echo
+  echo "Input option [b]:"
+  read option
+  [ "$option" = "" ] && option=b
+else
+  option=$1
+fi
+
+case $option in
+  a)
+    echo "Advanced deployment"
+    DEPLOYMENTS_DIR=deployments/advanced
+    DPATH_dflt=$HOME/ADL-advanced
+  ;;
+
+  b)
+    echo "Basic deployment"
+    DEPLOYMENTS_DIR=deployments/basic
+    DPATH_dflt=$HOME/ADL-basic
+  ;;
+
+  f)
+    echo "FT deployment"
+    DEPLOYMENTS_DIR=deployments/ft-client
+    DPATH_dflt=$HOME/ADL-ft-client
+  ;;
+
+  *)
+    _exit "Invalid deployment type '$option' !!"
+  ;;
+esac
+
+echo
+if [ "$2" = "" ]
+then
+  echo "Input deployment path [$DPATH_dflt]:"
+  read DPATH
+  [ "$DPATH" = "" ] && DPATH=$DPATH_dflt
+else
+  DPATH=$2
+fi
+
+[ -d $DPATH ] && _exit "The installation path '$DPATH' must not exists."
+
+echo "Copying to '$DPATH' ..."
+mkdir -p $DPATH
+mkdir -p $DPATH/stacks
+mkdir -p $DPATH/DTDs
+mkdir -p $DPATH/counters
+mkdir -p $DPATH/resources
+if [ "$EXEC" = "$EXEC_installed" ]
+then
+  ln -s $EXEC_installed $DPATH/ADL-launcher
+else
+  cp $EXEC $DPATH/ADL-launcher
+fi
+cp -rL $DEPLOYMENTS_DIR/* $DPATH
+cp resources/* $DPATH/resources
 cp $SETUPS_DIR/*xml $DPATH/stacks
 cp $SETUPS_DIR/*sh $DPATH/stacks
-cp $MSGDTD_DIR $DPATH
+cp $SETUPS_DIR/readme.txt $DPATH/stacks
+cp $MSGDTD $DPATH/DTDs
+cp $DCTDTD $DPATH/DTDs
 
 echo "Preparing ..."
 cd $DPATH
-createRunScript
+createRunScript $option
 createDictionaryPaths
 cd - >/dev/null
 
 # Help:
-echo "Stacks available at '.dictionary__<stack description>', create a symbolic link from '.dictionary'." >> tmp/README
-echo "Template for xml messages: message.dtd (informative, not actually required by process)" >> tmp/README
-echo "Start with 'run.sh'" >> tmp/README
-
-mv tmp ADL-installer
-tar cvfz ADL-installer.tar.gz ADL-installer
-rm -rf ADL-installer
-
 echo
-echo "Created ADL-installer.tar.gz !"
+echo "Go to '$DPATH' and see README file"
+echo
+echo "Done!"
+echo
 echo